/*
 * TUNA-CAN TOL-POT4f[^擾R[h Visual DSP++p
 *
 * Copyright(C) 2012-2013 Kaneko System Co., Ltd.
 *
 * Last Update: 2013/02/14
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include "bfin_twi.h"
#include "bfin_uart.h"

/* VXeNbN(99MHz) */
#define SCLOCK_HZ		(99000000)
/* {[[g(57600bps) */
#define UART0_BAUDRATE	(57600)

/* AD7999I2CX[uAhX */
#define ADC_I2C_SLAVE_ADDR (0x29)

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

/* w肳ꂽ}CNbҋ@ */
static void s_us_delay(uint32_t us)
{
	uint32_t l_start;
	uint32_t l_now;
	int32_t l_stop = us * (int32_t)(1000 / 2.5252525);	/* 1 cycle = 2.525..ns */

	asm("%0 = CYCLES;" : "=d"(l_start));
	while(1)
	{
		asm volatile("%0 = CYCLES;" : "=d"(l_now));
		if((l_now - l_start) >= l_stop)
			break;
	}
}

int main( void )
{
	char    l_text[32];
	uint8_t l_twi_val[2];
	uint8_t l_adc_val[4];
	int32_t l_lc;
	
	/* PLLݒ */
	s_bfin_clk_pll_set(33, 4);

	/* TWI */
	e_bfin_twi_init();
	/* UART */
	e_bfin_uart_init(UART0_BAUDRATE, SCLOCK_HZ);

	while(1)
	{
		for(l_lc = 0; l_lc < 4; l_lc++)
		{
			e_bfin_twi_master_read(ADC_I2C_SLAVE_ADDR, BFIN_TWI_STOP, l_twi_val, 2);
			while(e_bfin_twi_master_xfer_state() != BFIN_TWI_STATE_COMP) ssync();
			l_adc_val[l_twi_val[0] >> 4] = (l_twi_val[0] << 4) | (l_twi_val[1] >> 4);
		}

		sprintf(l_text, "CH0:%3d CH1:%3d CH2:%3d CH3:%3d\r\n", l_adc_val[0], l_adc_val[1], l_adc_val[2], l_adc_val[3]);
		e_bfin_uart_print(l_text);
		while(e_bfin_uart_write_chk() == BFIN_UART_ERR_DMABUSY) ssync();
		s_us_delay(250000);
	}
	return 0;
}
