#ifndef _BFIN_TWI_H_
#define _BFIN_TWI_H_

#define BFIN_TWI_STATE_ERROR	(-1)
#define BFIN_TWI_STATE_XFER		(0)
#define BFIN_TWI_STATE_COMP		(1)

#define BFIN_TWI_ERR_SUCCESS	(0)
#define BFIN_TWI_ERR_PARAM		(-1)

/* rstartp` */
#define BFIN_TWI_STOP			(0)
#define BFIN_TWI_RSTART			(1)

typedef struct
{
	uint8_t  state;
	uint8_t  access_mode;
	uint16_t count;
	uint8_t* p_buffer;
} BFIN_TWI_XFER_ITEM;

#define BFIN_TWI_MODE_READ			(0)
#define BFIN_TWI_MODE_WRITE			(1)
#define BFIN_TWI_MODE_READ_REPEAT	(2)
#define BFIN_TWI_MODE_WRITE_REPEAT	(3)

extern void e_bfin_twi_init(void);
extern int32_t e_bfin_twi_master_write_and_read(uint8_t slave_addr, const uint8_t* p_write_data, uint16_t write_cnt, uint8_t* p_read_data, uint16_t read_cnt);
extern int32_t e_bfin_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, uint16_t write_cnt);
extern int32_t e_bfin_twi_master_read(uint8_t slave_addr, int32_t rstart, uint8_t* p_data, uint16_t read_cnt);
extern int32_t e_bfin_twi_master_xfer_state(void);

#endif /* _BFIN_TWI_H_ */
